/**
*<BR> Name:          First Last
*<BR> Date:          0-00-0000
*<BR> Period:        0
*<BR> Assignment:    Lesson00
*<BR> Description:   In a sentence, what does this code do?
*<BR> Cite Sources:  Everyone who helped, and/or websites used
*<BR> Original Sources:	Jason Quesenberry and Nancy Quesenberry
*<BR> 					Original Visual Basic Code by Francesco Balena  https://amzn.to/2IZ15b3
*<BR>					Student Ryan Monroe for this line in constructor:  MyStrValue = "" + value;
*/

public class BaseConverterTester
{
    public static void main(String[] args)
    {
		//various tests for conversions that should work
		BaseConverter Tester00 = new BaseConverter();
		BaseConverter Tester01 = new BaseConverter(1054690345);
		BaseConverter Tester02 = new BaseConverter("111110110111010100110000101001", 2);
		BaseConverter Tester03 = new BaseConverter("7667246051", 8);
		BaseConverter Tester04 = new BaseConverter("3edd4C29");
		BaseConverter Tester05 = new BaseConverter("G9BG5H5", 20);
		BaseConverter Tester06 = new BaseConverter("257P889", 28);
		BaseConverter Tester07 = new BaseConverter("HFXOA1", 36);
		BaseConverter Tester08 = new BaseConverter(1234);
		
		//various tests for error messages, bad constructors
		BaseConverter Tester09 = new BaseConverter("HFXOA1", 16);			//error
		BaseConverter Tester10 = new BaseConverter("123456", 1);			//error
		BaseConverter Tester11 = new BaseConverter("", 16);					//error
		BaseConverter Tester12 = new BaseConverter("  FQ R?/- 1234  ", 36);	//error
		
		System.out.println();
		
		//decimalToAnyBase()
		System.out.println("decimalToAnyBase() tests:");
		System.out.println("(default constructor) 10 to base 2 is " + Tester00.decimalToAnyBase(2));
		System.out.println("(int value) 1054690345 to base 2 is " + Tester01.decimalToAnyBase(2));
		System.out.println("(int value) 1054690345 to base 8 is " + Tester01.decimalToAnyBase(8));
		System.out.println("(int value) 1054690345 to base 10 is " + Tester01.decimalToAnyBase(10));
		System.out.println("(int value) 1054690345 to base 16 is " + Tester01.decimalToAnyBase(16));
		System.out.println("(int value) 1054690345 to base 28 is " + Tester01.decimalToAnyBase(28));
		System.out.println("(int value) 1054690345 to base 36 is " + Tester01.decimalToAnyBase(36));
		System.out.println("(int value) 001234 to base 2 is " + Tester08.decimalToAnyBase(2));
		System.out.println();

		//anyBaseToDecimal()
		System.out.println("anyBaseToDecimal() tests:");
		System.out.println("(default constructor) 10 from base 10 to decimal is " + Tester00.anyBaseToDecimal());
		System.out.println("(int value) 1054690345 from base 10 to decimal is " + Tester01.anyBaseToDecimal());
		System.out.println("111110110111010100110000101001 from base 2 to decimal is " + Tester02.anyBaseToDecimal());
		System.out.println("(String value, int base) 7667246051 from base 8 to decimal is " + Tester03.anyBaseToDecimal());
		System.out.println("(String value) 3EDD4C29 base 16 to decimal is " + Tester04.anyBaseToDecimal());
		System.out.println("(String value, int base) G9BG5H5 from base 20 to decimal is " + Tester05.anyBaseToDecimal());
		System.out.println("(String value, int base) 257P889 from base 28 to decimal is " + Tester06.anyBaseToDecimal());
		System.out.println("(String value, int base) HFXOA1 from base 36 to decimal is " + Tester07.anyBaseToDecimal());
		System.out.println("(int value) 1234 from base 10 to decimal is " + Tester08.anyBaseToDecimal());
		System.out.println();
		
		//anyBaseToDecimal() various error checking tests
		System.out.println("anyBaseToDecimal() ERROR tests:");
		System.out.println();
		System.out.println("(String value, int base) HFXOA1 from base 16 to decimal is " + Tester09.anyBaseToDecimal());
		System.out.println();
		System.out.println("(String value, int base) 123456 from base 1 to decimal is " + Tester10.anyBaseToDecimal());
		System.out.println();
		System.out.println("(String value, int base) \"\" (empty string) from base 16 to decimal is  " + Tester11.anyBaseToDecimal());
		System.out.println();
		System.out.println("(String value, int base) (spaces in string) from base 36 to decimal is  " + Tester12.anyBaseToDecimal());
		System.out.println();
		
		//You provide decimalToAnyBase() various error checking tests
		System.out.println("decimalToAnyBase() ERROR tests:");
		System.out.println("STUDENTS SHOULD CREATE THESE...");
		System.out.println("STUDENTS SHOULD CREATE THESE...");
		System.out.println("STUDENTS SHOULD CREATE THESE...");
		System.out.println("STUDENTS SHOULD CREATE THESE...");
		//...
    }
}

/*

decimalToAnyBase() tests:
(default constructor) 10 to base 2 is 1010
(int value) 1054690345 to base 2 is 111110110111010100110000101001
(int value) 1054690345 to base 8 is 7667246051
(int value) 1054690345 to base 10 is 1054690345
(int value) 1054690345 to base 16 is 3EDD4C29
(int value) 1054690345 to base 28 is 257P889
(int value) 1054690345 to base 36 is HFXOA1
(int value) 1234 to base 2 is 10011010010

anyBaseToDecimal() tests:
(default constructor) 10 from base 10 to decimal is 10
(int value) 1054690345 from base 10 to decimal is 1054690345
111110110111010100110000101001 from base 2 to decimal is 1054690345
(String value, int base) 7667246051 from base 8 to decimal is 1054690345
(String value) 3EDD4C29 base 16 to decimal is 1054690345
(String value, int base) G9BG5H5 from base 20 to decimal is 1054690345
(String value, int base) 257P889 from base 28 to decimal is 1054690345
(String value, int base) HFXOA1 from base 36 to decimal is 1054690345
(int value) 1234 from base 10 to decimal is 1234

anyBaseToDecimal() ERROR tests:

ERROR:  Digit beyond the range of the base.
(String value, int base) HFXOA1 from base 16 to decimal is -1

ERROR:  base must be in the range 2 to 36
(String value, int base) 123456 from base 1 to decimal is -1

ERROR:  empty string value provided
(String value, int base) "" (empty string) from base 16 to decimal is  -1

*/